<template>
  <div class="grid-container-fluid">
      <div class="grid-column-two-thirds">
        <img src="@/assets/logos/logo.svg" alt="Uncover Logo">
      </div>
      <div class="grid-column-one-third">
        <form @submit.prevent class="grid-form">
          <h1 class="title is-size-2 has-text-white">{{ pageTitle }}</h1>
          <br />
          <b-field
          type="is-white">
            <b-input
              type="email"
              icon="envelope"
              placeholder="Email"
              v-model="user.email">
            </b-input>
          </b-field>
          <b-field
          type="is-white">
            <b-input
              type="password"
              icon="key"
              placeholder="Password"
              v-model="user.password">
            </b-input>
          </b-field>
          <br />
          <div class="control is-expanded">
            <button
            class="button is-white is-expanded has-text-weight-bold has-text-uppercase"
            :class="{'is-loading': isLoading}"
            @click="submitForm">
            {{ pageTitle }}
            </button>
          </div>
          <br />
          <br />
          <br />
          <div class="field is-grouped">
            <div class="control is-expanded">
              <button class="button is-text" @click="$router.push('/')">Go Back</button>
            </div>
            <div class="control">
              <button class="button is-primary is-outlined" @click="isLogin = !isLogin">{{ !isLogin ? 'Login' : 'Sign Up' }}</button>
            </div>
          </div>
        </form>
      </div>
  </div>
</template>

<script>
//* Import GQL Queries
import SIGNUPUSER_MUTATION from '@/graphql/Auth/SignUpUser.gql'
import AUTHENTICATEUSER_MUTATION from '@/graphql/Auth/AuthenticateUser.gql'
export default {
  name: 'login',
  data () {
    return {
      user: {},
      isLogin: true,
      isLoading: false
    }
  },
  computed: {
    pageTitle () {
      return this.isLogin ? 'Login' : 'Sign Up'
    }
  },
  created () {
    if (localStorage.getItem('apollo-token')) this.$router.push({ name: 'feed' })
  },
  methods: {
    submitForm () {
      if (this.isLogin) this.loginUser()
      else this.signUpUser()
    },
    signUpUser () {
      this.isLoading = true
      const { email, password } = this.user
      this.$apollo.mutate({
        mutation: SIGNUPUSER_MUTATION,
        variables: {
          email,
          password
        }
      }).then(({data: { signupUser }}) => {
        this.$store.dispatch('addUserAuth', signupUser)
        this.$router.push({ name: 'onboard-account' })
      }).catch(error => {
        console.error(error)
        this.isLoading = false
        this.$dialog.alert({
          title: 'Error',
          message: error.message,
          type: 'is-danger',
          hasIcon: true,
          icon: 'times-circle',
          iconPack: 'fa'
        })
      })
    },
    loginUser () {
      this.isLoading = true
      const { email, password } = this.user
      this.$apollo.mutate({
        mutation: AUTHENTICATEUSER_MUTATION,
        variables: {
          email,
          password
        }
      }).then(({ data: { authenticateUser } }) => {
        this.$store.dispatch('addUserAuth', authenticateUser)
        this.$router.push({ name: 'feed' })
      }).catch(error => {
        console.error(error)
        this.isLoading = false
        this.$dialog.alert({
          title: 'Error',
          message: error.message,
          type: 'is-danger',
          hasIcon: true,
          icon: 'times-circle',
          iconPack: 'fa'
        })
      })
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~bulma/sass/utilities/initial-variables";
@import "@/assets/scss/_variables.scss";

*{
  box-sizing: border-box;
  padding: 0;
  margin: 0;
}

.grid-container-fluid {
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  grid-template-rows: repeat(3, 1fr);
  width: 100vw;
  height: 100vh;
  background-color: $white;
}

.grid-column-two-thirds {
  grid-column: 1 / span 2;
  grid-row: span 3;
  display: grid;
  grid-template-columns: repeat(3, 1fr);
  grid-template-rows: repeat(3, 1fr);
  justify-content: center;
  img {
    grid-column: 2;
    grid-row: 2;
    align-self: center;
  }
}

.grid-column-one-third {
  grid-column: 3 / span 2;
  grid-row: span 3;
  padding: 5rem 3rem;
  background-color: $grey;
  display: grid;
  grid-template-columns: repeat(6, 1fr);
  grid-template-rows: repeat(3, 1fr);
  justify-content: center;
  .grid-form {
    grid-column: 2 / span 4;
    grid-row: 2;
    align-self: center;
    color: $white;
  }
}

.button.is-expanded {
  width: 100%;
}
</style>
